/* Sensor2

  R4 and R4.5 version Copyright (c) 1999 Andrew Vessey
  Original R3 version Copyright (c) 1998 Mathias Agopian
  All Rights Reserved.

  Contributing Author(s):

     Andrew Vessey <andrew@pixira.com> (R4 stuff - prefs, minisensor)
     Mathias Agopian (original R3 version of sensorapp, sensorwin, mlm78
     Marco Nelissen <marcone@xs4all.nl> (bubblehelper class)

  The contributing author(s) would like to thank all those who
  helped with testing, bug fixes, and patience.  This wouldn't
  have been possible without all of you.

  COPYRIGHT NOTICE:
 
  This software and documentation is provided "as is," and
  the copyright holders and contributing author(s) make no
  representations or warranties, express or implied, including
  but not limited to, warranties of merchantability or fitness
  for any particular purpose or that the use of the software or
  documentation will not infringe any third party patents,
  copyrights, trademarks or other rights. 

  The copyright holders and contributing author(s) will not be
  liable for any direct, indirect, special or consequential damages
  arising out of any use of the software or documentation, even if
  advised of the possibility of such damage.

  Permission is hereby granted to use, copy, modify, and distribute
  this source code, or portions hereof, documentation and executables,
  for any purpose, without fee, subject to the following restrictions:

  1. The origin of this source code must not be misrepresented.
  2. Altered versions must be plainly marked as such and must
     not be misrepresented as being the original source.
  3. This Copyright notice may not be removed or altered from any
     source or altered source distribution.
 
  The copyright holders and contributing author(s) specifically
  permit, without fee, and encourage the use of this source code
  as a component for developing system monitoring applications for 
  the BeOS.  If you use this source code in a product,
  acknowledgment is not required but would be appreciated.
*/
 
#include "Mlm78.h"
#include <string.h>
#include <iostream.h>
#include <stdio.h>


Mlm78::Mlm78(void)
{
	fSensorDevice = new BFile("/dev/misc/lm78", B_READ_ONLY);
}

Mlm78::~Mlm78(void)
{
	delete fSensorDevice;
}

status_t Mlm78::InitCheck(void)
{
	return fSensorDevice->InitCheck();
}

static void calcFan(int *f)
{	if(*f==255)
		*f=-1;//no fan
	else if(*f==0)
		*f=0;//don't divide by zero!
	else
		*f=(2*337500)/(*f);
}

int32 Mlm78::Update (void)
{	char buffer[256];
	char *buf = buffer;
	ssize_t len;
	len = fSensorDevice->Read(buf, 256);
	
	buf = strchr(buf,':')+1;
	sscanf(buf, "%f\n", &(VoltCore[0]));
	VoltCore[0]=(VoltCore[0]*200/125)/100;
	
	buf = strchr(buf,':')+1;
	sscanf(buf, "%f\n", &VoltVTT);
	VoltVTT=(VoltVTT*200/125)/100;
	
	buf = strchr(buf,':')+1;
	sscanf(buf, "%f\n", &VoltVIO);
	VoltVIO=(VoltVIO*200/125)/100;
	
	buf = strchr(buf,':')+1;
	sscanf(buf, "%f\n", &VoltP5);
	VoltP5=(VoltP5*334/125)/100;
	
	buf = strchr(buf,':')+1;
	sscanf(buf, "%f\n", &VoltP12);
	VoltP12=(VoltP12*758/125)/100;
	
	buf = strchr(buf,':')+1;
	sscanf(buf, "%f\n", &VoltM12);
	VoltM12=((VoltM12*514)/100-1391)/100; /*guess*/
	
	buf = strchr(buf,':')+1;
	sscanf(buf, "%f\n", &VoltM5);
	VoltM5=((VoltM5*314)/100-641)/100; /*guess*/
	
	buf = strchr(buf,':')+1;
	sscanf(buf, "%f\n", &Volt5VSB);
	Volt5VSB=(Volt5VSB*500/125)/100;//guess
	
	buf = strchr(buf,':')+1;
	sscanf(buf, "%f\n", &(VoltCore[1]));
	VoltCore[1]=(VoltCore[1]*200/188)/100;//guess
	
	buf = strchr(buf,':')+1;
	sscanf(buf, "%d\n", &(TempCPU[1]));
	
	buf = strchr(buf,':')+1;
	sscanf(buf, "%d\n", &(TempCPU[0]));//yes 0 & 1 are swapped
	
	buf = strchr(buf,':')+1;
	sscanf(buf, "%d\n", &(TempCPU[2]));//motherboard
	
	buf = strchr(buf,':')+1;
	sscanf(buf, "%d\n", &(FanCPU[0]));
	calcFan(&(FanCPU[0]));
	
	buf = strchr(buf,':')+1;
	sscanf(buf, "%d\n", &(FanCPU[1]));
	calcFan(&(FanCPU[1]));
	
	buf = strchr(buf,':')+1;
	sscanf(buf, "%d\n", &(FanCPU[2]));
	calcFan(&(FanCPU[2]));
	
	return 0;
}
